<?php 
/* ---------------------------------------------------- */
/*                        MYSQL CNX/BDD                 */
/* ---------------------------------------------------- */

/* Connexion à la base données */
 function connexionDB()
{
	include('config.php');
	$mysqli = new mysqli($BDD_HOSTNAME, $BDD_USERNAME, $BDD_PASSWORD,$BDD_DBNAME);
	if (mysqli_connect_error()) {
	    die('Erreur de connexion (' . mysqli_connect_errno() . ') '
	            . mysqli_connect_error());
	}
	return $mysqli;
}

/* Deconnexion à la base données */
 function disconnectDB($link)
{	
	mysqli_close($link);
}


//Retourne le tableau des HORAIRES
function getHORAIRES()
{	
	include('config.php');
	return $HORAIRES;
}

//Retourne le tableau des JOURS
function getJOURS()
{	
	include('config.php');
	return $JOURS;
}

/* 
	fonction : get_EDT() 
	Chargement de l'edt dans un tableau 
	le tableau est envoyé en retour
*/
 function getEDT($classe_id)
{	
	$link=connexionDB();
	$sql="SELECT cours.id as id,jour,";
	$sql.="id_salle,id_matiere,id_classe, ";
	$sql.="matieres.nom as matiere,";
	$sql.="salles.nom as salle,";
	$sql.="classes.nom as classe,";
	$sql.="heure_debut,heure_fin ";
	$sql.=" FROM cours,matieres,salles,classes ";
	$sql.=" WHERE cours.id_matiere=matieres.id ";
	$sql.=" AND cours.id_salle=salles.id ";
	$sql.=" AND cours.id_classe=classes.id ";
	$sql.=" AND classes.id='".$classe_id."'";

	$result=$link->query($sql);
	$t_edt=array();
	while($row = $result->fetch_array()) { 
		$t_edt[]=$row;
	}

	return $t_edt;
}


/* ---------------------------------------------------- */
/*                        COURS                         */
/* ---------------------------------------------------- */
/* 
	Fonction : getCours($t_edt,$h,$j) 
	paramêtres : $t_edt=tableau de l'edt ; $h=heure de début du cours ; $j=nom du jour en majuscules
 	Fontion qui renvoie la chaine <td>cours+salle</td> pour l'heure et le jour donnés.
 	Le tableau t_edt est balayé pour trouver le cours correspondant.
 	Un rowspan='nbh' est ajouté pour la première heure d'un cours de plus d'une heure
 	Une chaine vide est renvoyée pour la (1+nième) heure d'un cours de plus d'une heure.
 	Une chaine <td></td> si aucun cours ne correspond
*/
function getCours($classe_id,$t_edt,$h,$j,$edit=true) {	

	$result="<td>";
	$lien_new="<a href='../cours/cours_new.php?jour=".$j."&heure_debut=".$h."&classe_id=".$classe_id."'>";
	$lien_new.="<img border='0' src='../img/add_mini.png' width='18px' height='18px'/>";
	$lien_new.="</a>";
	$result="<td>".$lien_new."</td>";

	for($i=0;$i<count($t_edt);$i++) { 
		$jour=$t_edt[$i]["jour"];
		$cours_salle=$t_edt[$i]["matiere"]."<br/>Salle ".$t_edt[$i]["salle"];
		$debut=$t_edt[$i]["heure_debut"];
		$fin=$t_edt[$i]["heure_fin"];
		$id=$t_edt[$i]["id"];
		$classe_id=$t_edt[$i]["id_classe"];
		$result="";
		$rowspan="";
		if( ($jour==$j) && ($h>=$debut)&&($h<$fin) ) {
			$heuredeb=intval(substr($debut,0,2)); 	//Transfomration de l'heure de debut en numérique sans minutes
			$heurefin=intval(substr($fin,0,2)); 	//Transfomration de l'heure de fin en numérique sans minutes
			$nbheure=$heurefin-$heuredeb;
			if($nbheure>1) {
				if($h==$debut)  $rowspan="rowspan='".$nbheure."'";
				else return "";
			}
			if($edit) {
				$lien_delete="<a href='../cours/cours_delete.php?classe_id=".$classe_id."&delete_id=".$id."'>";
				$lien_delete.="<img border='0' style='margin:3px' src='../img/sup_mini.png' width='18px' height='18px'/>";
				$lien_delete.="</a>";
				$result="<td ".$rowspan.">".$cours_salle.$lien_delete."</td>";
			} else {
				$result="<td ".$rowspan.">".$cours_salle."</td>";
			}
			break;
		} else {
			if($edit) {
				$result="<td>";
				$result.=$lien_new;
				$result.="</td>";
			}
			else $result="<td></td>";
		}
	}
	return $result."\n";
}

/* 
	fonction : setCOURS() 
	Mise à jour d'un cours ou Création si Id=''
	paramètres : $t_cours tableau de nom des champs
*/
 function setCOURS($t_cours)
{	
	$link=connexionDB();

	if($t_cours['id']!="") {
		$sql="update id_salle='".$t_cours['id_salle']."',id_matiere='".$t_cours['id_matiere']."',".
			"id_classe='".$t_cours['id_classe']."',heure_debut='".$t_cours['heure_debut']."',".
			"heure_fin='".$t_cours['heure_fin']."' where id=".$t_cours['id'];
	} else {
		$sql="insert into cours values (NULL,'".$t_cours['id_classe']."','"
			.$t_cours['id_matiere']."','"
			.$t_cours['id_salle']."','"
			.$t_cours['jour']."','"
			.$t_cours['heure_debut']."','"
			.$t_cours['heure_fin']."')";
	}

	$result=$link->query($sql);
	return $result;
}


/*  
	fonction : deleteCOURS() 
	Supprime une classe
	paramètres : id=>identifiant 
*/
 function deleteCOURS($id)
{	
	$link=connexionDB();
	$sql="delete from cours where id=".$id;
	$result=$link->query($sql);
	return $result;
}

/* ---------------------------------------------------- */
/*                      CLASSES                         */
/* ---------------------------------------------------- */
/* 
	fonction : getCLASSES() 
	Chargement des classes un tableau 
	le tableau est envoyé en retour
*/
 function getCLASSES()
{	
	$link=connexionDB();
	$sql="select distinct id,nom from classes order by nom";
	$result=$link->query($sql);
	$t_classes=array();
	//chargement dans un tableau 
	while($row = $result->fetch_array()) { 
		$t_classes[$row['id']]=$row['nom'];
	}
	return $t_classes;
}

/*
	fonction : getCLASSE() 
	Chargement d'une Classe dans un tableau 
	Return : tableau [id=>nom];
*/
 function getCLASSE($id)
{	
	$link=connexionDB();
	$sql="select id,nom from classes where classes.id=".$id;
	$result=$link->query($sql);
	$t=array();
	//chargement dans un tableau 
	if($row = $result->fetch_array()) { 
		$t['id']=$row['id'];
		$t['nom']=$row['nom'];
	}
	return $t;
}

/* 
	fonction : setCLASSE() 
	Mise à jour d'une classe ou Création si Id=''
	paramètres : id=>identifiant ; nom=>Libellé de la classe
*/
 function setCLASSE($nom,$id="")
{	
	$link=connexionDB();
	$sql="";
	if($id!="") $sql="update classes set nom='".$nom."' where id=".$id;
	else $sql="insert into classes values (NULL,'".$nom."')";
	$result=$link->query($sql);
	return $result;
}

/*  
	fonction : deleteCLASSE() 
	Supprime une classe
	paramètres : id=>identifiant 
*/
 function deleteCLASSE($id)
{	
	$link=connexionDB();
	$sql="delete from classes where id=".$id;
	$result=$link->query($sql);
	return $result;
}


/* ---------------------------------------------------- */
/*                      MATIERES                         */
/* ---------------------------------------------------- */
/* 
	fonction : getMATIERES() 
	Chargement des matières un tableau 
	le tableau est envoyé en retour
*/
 function getMATIERES()
{	
	$link=connexionDB();
	$sql="select distinct id,nom from matieres order by nom";
	$result=$link->query($sql);
	$t_matieres=array();
	//chargement dans un tableau 
	while($row = $result->fetch_array()) { 
		$t_matieres[$row['id']]=$row['nom'];
	}
	return $t_matieres;
}

/*
	fonction : getMATIERE() 
	Chargement d'une Matiere dans un tableau 
	Return : tableau [id=>nom];
*/
 function getMATIERE($id)
{	
	$link=connexionDB();
	$sql="select id,nom from matieres where matieres.id=".$id;
	$result=$link->query($sql);
	$t=array();
	//chargement dans un tableau 
	if($row = $result->fetch_array()) { 
		$t['id']=$row['id'];
		$t['nom']=$row['nom'];
	}
	return $t;
}

/* 
	fonction : setMATIERE() 
	Mise à jour d'une matière ou Création si Id=''
	paramètres : id=>identifiant ; nom=>Libellé de la matière
*/
 function setMATIERE($nom,$id="")
{	
	$link=connexionDB();
	$sql="";
	if($id!="") $sql="update matieres set nom='".$nom."' where id=".$id;
	else $sql="insert into matieres values (NULL,'".$nom."')";
	$result=$link->query($sql);
	return $result;
}

/*  
	fonction : deleteMATIERE() 
	Supprime une matiere
	paramètres : id=>identifiant 
*/
 function deleteMATIERE($id)
{	
	$link=connexionDB();
	$sql="delete from matieres where id=".$id;
	$result=$link->query($sql);
	return $result;
}



/* ---------------------------------------------------- */
/*                      SALLES                          */
/* ---------------------------------------------------- */
/* 
	fonction : getSALLES() 
	Chargement des salles un tableau 
	le tableau est envoyé en retour
*/
 function getSALLES()
{	
	$link=connexionDB();
	$sql="select distinct id,nom from salles order by nom";
	$result=$link->query($sql);
	$t_salles=array();
	//chargement dans un tableau 
	while($row = $result->fetch_array()) { 
		$t_salles[$row['id']]=$row['nom'];
	}
	return $t_salles;
}

/*
	fonction : getSALLE() 
	Chargement d'une Salle dans un tableau 
	Return : tableau [id=>nom];
*/
 function getSALLE($id)
{	
	$link=connexionDB();
	$sql="select id,nom from salles where salles.id=".$id;
	$result=$link->query($sql);
	$t=array();
	//chargement dans un tableau 
	if($row = $result->fetch_array()) { 
		$t['id']=$row['id'];
		$t['nom']=$row['nom'];
	}
	return $t;
}

/* 
	fonction : setSALLE() 
	Mise à jour d'une salle ou Création si Id=''
	paramètres : id=>identifiant ; nom=>Libellé de la salle
*/
 function setSALLE($nom,$id="")
{	
	$link=connexionDB();
	$sql="";
	if($id!="") $sql="update salles set nom='".$nom."' where id=".$id;
	else $sql="insert into salles values (NULL,'".$nom."')";
	$result=$link->query($sql);
	return $result;
}

/*  
	fonction : deleteSALLE() 
	Supprime une salle
	paramètres : id=>identifiant 
*/
 function deleteSALLE($id)
{	
	$link=connexionDB();
	$sql="delete from salles where id=".$id;
	$result=$link->query($sql);
	return $result;
}
?>